;standard routines needed for pretty much all games
;read switches, joysticks, position sprites, set score pointers,
;call the kernel, etc.

;switch register
switchreset
 lda #1
 bit SWCHB
 rts

switchselect
 lda #2
 bit SWCHB
 rts

switchleftb
 lda #$40
 bit SWCHB
 rts

switchrightb
 lda #$80
 bit SWCHB
 rts

switchbw
 lda #8
 bit SWCHB
 rts

;joyx routines return Z=0 if joystick is pressed that direction, otherwise Z=1.
joy0up
 lda #$10
 bit SWCHA
 rts

joy0down
 lda #$20
 bit SWCHA
 rts 

joy0left
 lda #$40
 bit SWCHA
 rts 

joy0right
 lda #$80
 bit SWCHA
 rts 
 
joy0fire
 lda #$80
 bit INPT4
 rts


horpos
 sec
 sta WSYNC
rept
 sbc #15
 bcs rept
 eor #7
 asl
 asl
 asl
 asl
 sta RESP0,x
 sta HMP0,x
 sta WSYNC
 sta HMOVE
 sleep 24
 sta HMCLR
 rts
 
playerset ;x: 0=p0, 1=p0, 2=m0, 3=m1, 4=bl
; a=horpos
; y=verpos
 jsr horpos 
 sty objecty,x
 rts

randomize
 lda rand
 lsr
 bcc noeor
 eor #$B2
noeor
 sta rand
 rts

scorepointerset
 tax
 and #$0F
 asl
 asl
 asl
 adc #<scoretable
 tay
 txa
 and #$F0
 lsr
 adc #<scoretable
 tax
 rts
